// Rally 6/10/16
// Adapted from Weapon_Gun.zip

//==================
// Audio Datablocks
//==================

datablock AudioProfile(musketBasicShot1Sound)
{
   filename    = "./sounds/musketFire2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(musketBasicShot2Sound)
{
   filename    = "./sounds/musketFire3.wav";
   description = AudioClose3d;
   preload = true;
};

//===============
// Recoil Effect
//===============

datablock ExplosionData(MusketRecoilExplosion)
{
   explosionShape = "";

   lifeTimeMS = 150;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
  camShakeFreq = "2 2 2";
  camShakeAmp = "0.7 0.7 0.7";
   camShakeDuration = 0.25;
   camShakeRadius = 10.0;
};

datablock ProjectileData(MusketRecoilProjectile)
{
	lifetime						= 10;
	fadeDelay						= 10;
	explodeondeath						= true;
	explosion						= MusketRecoilExplosion;

};

//==============
// Muzzle Flash
//==============

datablock ParticleData(musketBasicFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1.0 0.3 0.3 0.9";
	colors[1]     = "1.0 0.3 0.0 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 4.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(musketBasicFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "musketBasicFlashParticle";

   uiName = "Musket Flash";
};

//==============
// Muzzle Smoke
//==============

datablock ParticleData(musketBasicSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 5500;
	lifetimeVarianceMS   = 3000;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.3";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 4.00;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(musketBasicSmokeEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 50.0;
   velocityVariance = 45.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 45;
   phiReferenceVel  = 0;
   phiVariance      = 90;
   overrideAdvance = false;
   particles = "musketBasicSmokeParticle";

   uiName = "musketBasic Smoke";
};

//========================
// Bullet Trail Datablock 
//========================

datablock ParticleData(MusketBallTrailParticle)
{
	dragCoefficient      = 90;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 125;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[2]     = "1.0 1.0 1.0 0.0";  // red cool gas
	colors[1]     = "1.0 1.0 1.0 0.3";  // warm yellow gas
	colors[0]     = "1.0 1.0 1.0 0.5";  // hot white gas first
	sizes[0]      = 0.76;
	sizes[1]      = 0.09;
	sizes[2]	  = 0.06;
	times[0]      = 0.0;
	times[1]	  = 0.1;
	times[2]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(MusketBallTrailEmitter)
{
   ejectionPeriodMS = 8;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MusketBallTrailParticle";
   uiname = "Musket Ball Trail";
};

//==========================================
// Musket Ball Explosion (Obsolete for now)
//==========================================

// datablock ParticleData(musketBasicExplosionParticle)
// {
	// dragCoefficient      = 8;
	// gravityCoefficient   = 1;
	// inheritedVelFactor   = 0.2;
	// constantAcceleration = 0.0;
	// lifetimeMS           = 700;
	// lifetimeVarianceMS   = 400;
	// textureName          = "base/data/particles/cloud";
	// spinSpeed		= 10.0;
	// spinRandomMin		= -50.0;
	// spinRandomMax		= 50.0;
	// colors[0]     = "0.9 0.9 0.9 0.3";
	// colors[1]     = "0.9 0.5 0.6 0.0";
	// sizes[0]      = 0.25;
	// sizes[1]      = 0.75;

	// useInvAlpha = true;
// };

// datablock ParticleEmitterData(musketBasicExplosionEmitter)
// {
   // ejectionPeriodMS = 1;
   // periodVarianceMS = 0;
   // ejectionVelocity = 2;
   // velocityVariance = 1.0;
   // ejectionOffset   = 0.0;
   // thetaMin         = 89;
   // thetaMax         = 90;
   // phiReferenceVel  = 0;
   // phiVariance      = 360;
   // overrideAdvance = false;
   // particles = "musketBasicExplosionParticle";

   // useEmitterColors = true;
   // uiName = "musketBasic Hit Dust";
// };


// datablock ParticleData(musketBasicExplosionRingParticle)
// {
	// dragCoefficient      = 8;
	// gravityCoefficient   = -0.5;
	// inheritedVelFactor   = 0.2;
	// constantAcceleration = 0.0;
	// lifetimeMS           = 50;
	// lifetimeVarianceMS   = 35;
	// textureName          = "base/data/particles/star1";
	// spinSpeed		= 500.0;
	// spinRandomMin		= -500.0;
	// spinRandomMax		= 500.0;
	// colors[0]     = "1 1 0.0 0.9";
	// colors[1]     = "0.9 0.0 0.0 0.0";
	// sizes[0]      = 1;
	// sizes[1]      = 0;

	// useInvAlpha = false;
// };
// datablock ParticleEmitterData(musketBasicExplosionRingEmitter)
// {
	// lifeTimeMS = 50;

   // ejectionPeriodMS = 3;
   // periodVarianceMS = 0;
   // ejectionVelocity = 0;
   // velocityVariance = 0.0;
   // ejectionOffset   = 0.0;
   // thetaMin         = 89;
   // thetaMax         = 90;
   // phiReferenceVel  = 0;
   // phiVariance      = 360;
   // overrideAdvance = false;
   // particles = "musketBasicExplosionRingParticle";

   // useEmitterColors = true;
   // uiName = "musketBasic Hit Flash";
// };

// datablock ExplosionData(musketBasicExplosion)
// {
   // //explosionShape = "";
	// soundProfile = bulletHitSound;

   // lifeTimeMS = 150;

   // particleEmitter = musketBasicExplosionEmitter;
   // particleDensity = 5;
   // particleRadius = 0.2;

   // emitter[0] = musketBasicExplosionRingEmitter;

   // faceViewer     = true;
   // explosionScale = "1 1 1";

   // shakeCamera = false;
   // camShakeFreq = "10.0 11.0 10.0";
   // camShakeAmp = "1.0 1.0 1.0";
   // camShakeDuration = 0.5;
   // camShakeRadius = 10.0;

   // // Dynamic light
   // lightStartRadius = 2;
   // lightEndRadius = 2;
   // lightStartColor = "0.5 0.8 0.9";
   // lightEndColor = "0 0 0";
// };

//============
// Projectile
//============

AddDamageType("musketBall",   '<bitmap:add-ons/Weapon_musketBasic/CI_musketBasic> %1',    '%2 <bitmap:add-ons/Weapon_musketBasic/CI_musketBasic> %1',0.2,1);
datablock ProjectileData(musketBasicProjectile)
{
   projectileShapeName = "./shape/musketBall.dts";
   directDamage        = 34;
   directDamageType    = $DamageType::musketBasic;
   radiusDamageType    = $DamageType::musketBasic;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = spearExplosion;
   particleEmitter     = MusketBallTrailEmitter; //bulletTrailEmitter;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 1.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Musket Ball";
};

//=================
// Item Datablock
//=================

datablock ItemData(musketBasicItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	//shapeFile = "Add-Ons/Weapon_MusketGuns/shape/musketBasic.dts";
	shapeFile = "./shape/musketBasic.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Musket - Basic";
	iconName = "./icon_musketBasic";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = musketBasicImage;
	canDrop = true;
};

//=================
// Weapon Image
//=================

datablock ShapeBaseImageData(musketBasicImage)
{
   // Basic Item properties
   shapeFile = "Add-Ons/Weapon_MusketGuns/shape/musketBasic.dts";
	//shapeFile = "./shape/musketBasic.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   //projectile = musketBasicProjectile;
   //projectile = "";
   projectileType = Projectile;

	casing = musketBasicShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   colorShiftColor = musketBasicItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]            	= 0.15;
	stateTransitionOnTimeout[0]       	= "ReloadStage1";
	stateSound[0]						= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
    stateTransitionOnNoAmmo[1]       = "NoAmmo";
	stateAllowImageChange[1]         = true;
	stateSequence[1]				 = "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.0;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= musketBasicFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateEjectShell[2]       		= true;

	stateName[3] 					= "Smoke";
	stateEmitter[3]					= musketBasicSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.5;
	stateTransitionOnTimeout[3]     = "ReloadStage1";
	stateAllowImageChange[3]        = true;

	stateName[4]					= "ReloadStage1";
	stateSequence[4]                = "Ready";
	stateScript[4]                  = "onReloadStage1";
	stateTransitionOnTimeout[4]     = "ReloadStage2";
	stateTimeoutValue[4]            = 1.5;
	stateAllowImageChange[4]        = true;
	
	stateName[5]					= "ReloadStage2";
	stateSequence[5]                = "Ready";
	stateScript[5]                  = "onReloadStage2";
	stateTransitionOnTimeout[5]     = "Reload";
	stateTimeoutValue[5]            = 0.5;
	stateAllowImageChange[5]        = true;
	
	stateName[6]					= "Reload";
	stateSequence[6]                = "Ready";
	stateScript[6]                  = "onReloadStage3";
	stateTimeoutValue[6]            = 0.0;
	stateTransitionOnTimeout[6]     = "Ready";
	stateAllowImageChange[6]        = true;
	
	stateName[7]					= "NoAmmo";
	stateTransitionOnAmmo[7] 		= "Ready";
};

//===========
// Functions
//===========

function musketBasicImage::onFire(%this,%obj,%slot)
{

	// Recoil Explosion
	%obj.spawnExplosion(MusketRecoilProjectile,"2.5 2.5 2.5");
	
	// Muzzleshot sound effect
	%rand = getRandom(0,1);
	if(!%rand)
	{
		serverplay3d("musketBasicShot1Sound", %obj.getHackPosition() SPC "0 0 1 0");
	}
	else
	{
		serverplay3d("musketBasicShot2Sound", %obj.getHackPosition() SPC "0 0 1 0");	
	}

	// Spread and projectile
	%projectile = musketBasicProjectile;
	%spread = 0.01;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	
	// Return projectile
	return %p;
}

function musketBasicImage::onReloadStage1(%this,%obj,%slot)
{
	// Reload Stage 1
	%obj.playAudio(1, brickRotateSound);
	%obj.playThread(2, shiftRight);
}

function musketBasicImage::onReloadStage2(%this,%obj,%slot)
{
	// Reload Stage 2
	%obj.playAudio(1, brickMoveSound);
	%obj.playThread(2, shiftLeft);
}

function musketBasicImage::onReloadStage3(%this,%obj,%slot)
{
	// Reload Stage 3
	%obj.playAudio(1, brickPlantSound);
	%obj.playThread(2, plant);
}