// Rally 6/10/16
// Adapted from Weapon_Gun.zip

//==================
// Audio Datablocks
//==================



//===============
// Recoil Effect
//===============


//==============
// Muzzle Flash
//==============


//==============
// Muzzle Smoke
//==============


//========================
// Bullet Trail Datablock 
//========================


//==========================================
// Musket Ball Explosion (Obsolete for now)
//==========================================


//=================
// Item Datablock
//=================

datablock ItemData(musketLongItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	//shapeFile = "Add-Ons/Weapon_MusketGuns/shape/musketLong.dts";
	shapeFile = "./shape/musketLong.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Musket - Long";
	iconName = "./icon_musketLong";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = musketLongImage;
	canDrop = true;
};

//=================
// Weapon Image
//=================

datablock ShapeBaseImageData(musketLongImage)
{
   // Basic Item properties
   shapeFile = "Add-Ons/Weapon_MusketGuns/shape/musketLong.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   //projectile = musketLongProjectile;
   //projectile = "";
   projectileType = Projectile;

	casing = musketLongShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   colorShiftColor = musketLongItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]            	= 0.15;
	stateTransitionOnTimeout[0]       	= "ReloadStage1";
	stateSound[0]						= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
    stateTransitionOnNoAmmo[1]       = "NoAmmo";
	stateAllowImageChange[1]         = true;
	stateSequence[1]				 = "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.0;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= musketBasicFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateEjectShell[2]       		= true;

	stateName[3] 					= "Smoke";
	stateEmitter[3]					= musketBasicSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.5;
	stateTransitionOnTimeout[3]     = "ReloadStage1";
	stateAllowImageChange[3]        = true;

	stateName[4]					= "ReloadStage1";
	stateSequence[4]                = "Ready";
	stateScript[4]                  = "onReloadStage1";
	stateTransitionOnTimeout[4]     = "ReloadStage2";
	stateTimeoutValue[4]            = 3;
	stateAllowImageChange[4]        = true;
	
	stateName[5]					= "ReloadStage2";
	stateSequence[5]                = "Ready";
	stateScript[5]                  = "onReloadStage2";
	stateTransitionOnTimeout[5]     = "Reload";
	stateTimeoutValue[5]            = 1;
	stateAllowImageChange[5]        = true;
	
	stateName[6]					= "Reload";
	stateSequence[6]                = "Ready";
	stateScript[6]                  = "onReloadStage3";
	stateTimeoutValue[6]            = 0.0;
	stateTransitionOnTimeout[6]     = "Ready";
	stateAllowImageChange[6]        = true;
	
	stateName[7]					= "NoAmmo";
	stateTransitionOnAmmo[7] 		= "Ready";
};

//===========
// Functions
//===========

function musketLongImage::onFire(%this,%obj,%slot)
{

	// Recoil Explosion
	%obj.spawnExplosion(MusketRecoilProjectile,"2.5 2.5 2.5");
	
	// Muzzleshot sound effect
	%rand = getRandom(0,1);
	if(!%rand)
	{
		serverplay3d("musketBasicShot1Sound", %obj.getHackPosition() SPC "0 0 1 0");
	}
	else
	{
		serverplay3d("musketBasicShot2Sound", %obj.getHackPosition() SPC "0 0 1 0");	
	}

	// Spread and projectile
	%projectile = musketBasicProjectile;
	%spread = 0.00075;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	
	// Return projectile
	return %p;
}

function musketLongImage::onReloadStage1(%this,%obj,%slot)
{
	// Reload Stage 1
	%obj.playAudio(1, brickRotateSound);
	%obj.playThread(2, shiftRight);
}

function musketLongImage::onReloadStage2(%this,%obj,%slot)
{
	// Reload Stage 2
	%obj.playAudio(1, brickMoveSound);
	%obj.playThread(2, shiftLeft);
}

function musketLongImage::onReloadStage3(%this,%obj,%slot)
{
	// Reload Stage 3
	%obj.playAudio(1, brickPlantSound);
	%obj.playThread(2, plant);
}